void GLCDInit(char side);
void GLCDPrintColumn(char data, char side);
void GLCDSetRow(char row, char side);
void GLCDSetColumn(char column, char side);
void GLCDSetDisplayStartline(char startline, char side);
void GLCDOutc(char str, char xpos, char ypos, char* font);
void GLCDOuts(char* str, char xpos, char ypos, char* font);

void GLCDOuts(char* str, char xpos, char ypos, char* font)
{
  char i=0, j=0;
  char* back=str;
  while (*back++ != 0) j++;  // laenge des textes bestimmen
  if (font=="6x8") j*=6;  // *6 wegen breite eines einzelnen zeichens
  else if (font=="12x16") j*=12;  // *12 wegen breite eines einzelnen zeichens
  j=128-j;                // restbreite
  j/=2;                   // anfangsposition

  while (*str != 0)
  {
    if (xpos==128) GLCDOutc(*str, j+i, ypos, font);  // bei xpos=128 zentriert ausgeben
    else GLCDOutc(*str, xpos+i, ypos, font);
    if (font=="6x8") 
    {
      if (*str==','||*str=='.') i+=5;
      else i+=6;
    }
    else if (font=="12x16")
    {
      if (*str==','||*str=='.') i+=10;
      else i+=12;
    }
    str++;
  }
}

void GLCDOutc(char str, char xpos, char ypos, char* font)
{
  char i, side, other_side;

  if (str=='')
  {
    str-=49;              // grad-celsius-zeichen?
  }

  if (xpos<64)
  {
    side='l';
    other_side='r';
    GLCDSetRow(ypos, 'l');
    GLCDSetColumn(xpos, 'l');
  }
  else
  {
    xpos-=64;
    side='r';
    other_side='l';
    GLCDSetRow(ypos, 'r');
    GLCDSetColumn(xpos, 'r');
  }
  if (font=="6x8")
  {
    for (i=0;i<6;i++)
    {
      if (xpos+i>63)
      {
        GLCDSetRow(ypos, other_side);
        GLCDSetColumn(xpos+i-64, other_side);
        GLCDPrintColumn(Font6x8[(str-32)*6+i], other_side);
      }
      else GLCDPrintColumn(Font6x8[(str-32)*6+i], side);
    }
  }
  if (font=="12x16")
  {
    for (i=0;i<12;i++)
    { 
      if (xpos+i>63)
      {
        GLCDSetRow(ypos, other_side);
        GLCDSetColumn(xpos+i-64, other_side);
        GLCDPrintColumn(Font12x16[(str-32)*24+2*i], other_side);
      }
      else GLCDPrintColumn(Font12x16[(str-32)*24+2*i], side);  // erste zeile ausgeben (gerade indizes)
    }
    GLCDSetRow(ypos+1, side);
    GLCDSetColumn(xpos, side);
    for (i=0;i<12;i++)
    { 
      if (xpos+i>63)
      {
        GLCDSetRow(ypos+1, other_side);
        GLCDSetColumn(xpos+i-64, other_side);
        GLCDPrintColumn(Font12x16[(str-32)*24+1+2*i], other_side);
      }
      else GLCDPrintColumn(Font12x16[(str-32)*24+1+2*i], side);  // zweite zeile ausgeben (ungerade indizes)
    }
  }

}

void GLCDInit(char side)
{
  char i,j;
  
  if (side=='l') {CSPORT|=CS2; CSPORT&=~CS1;}  // left controller
  else if (side=='r') {CSPORT|=CS1; CSPORT&=~CS2;}  // right controller
  else if (side=='b') {CSPORT&=~CS1; CSPORT&=~CS2;}  // both controllers

  CONFIGPORT=0x00;
  DATAPORT=0x00;
  CONFIGPORT|=E; CONFIGPORT&=~RW; CONFIGPORT&=~DI;  // E=1, R/W=0, D/I=0
  DATAPORT=0x3F;          // switch LCD on
  CONFIGPORT&=~E;         // E=0

  for(j=0;j<8;j++)
  {
    GLCDSetRow(j, side);
    for(i=0;i<64;i++) GLCDPrintColumn(0, side);
  }

  GLCDSetRow(0, side);
}

void GLCDPrintColumn(char data, char side)
{
  if (side=='l') {CSPORT|=CS2; CSPORT&=~CS1;}  // left controller
  else if (side=='r') {CSPORT|=CS1; CSPORT&=~CS2;}  // right controller
  else if (side=='b') {CSPORT&=~CS1; CSPORT&=~CS2;}  // both controllers

  CONFIGPORT|=E; CONFIGPORT&=~RW; CONFIGPORT|=DI;  // E=1, R/W=0, D/I=1
  wait(1);
  DATAPORT=data;
  wait(1);
  CONFIGPORT&=~E;         // E=1
}

void GLCDSetRow(char row, char side)
{
  if (side=='l') {CSPORT|=CS2; CSPORT&=~CS1;}  // left controller
  else if (side=='r') {CSPORT|=CS1; CSPORT&=~CS2;}  // right controller
  else if (side=='b') {CSPORT&=~CS1; CSPORT&=~CS2;}  // both controllers

  CONFIGPORT|=E; CONFIGPORT&=~RW; CONFIGPORT&=~DI;  // E=1, R/W=0, D/I=0
  wait(1);
  DATAPORT=0xB8+row;
  wait(1);
  CONFIGPORT&=~E;         // E=0

  GLCDSetColumn(0, side);
}

void GLCDSetColumn(char column, char side)
{
  if (side=='l') {CSPORT|=CS2; CSPORT&=~CS1;}  // left controller
  else if (side=='r') {CSPORT|=CS1; CSPORT&=~CS2;}  // right controller
  else if (side=='b') {CSPORT&=~CS1; CSPORT&=~CS2;}  // both controllers

  CONFIGPORT|=E; CONFIGPORT&=~RW; CONFIGPORT&=~DI;  // E=1, R/W=0, D/I=0
  wait(1);
  DATAPORT=0x40+column;   // set Y-address
  wait(1);
  CONFIGPORT&=~E;         // E=0
}

void GLCDSetDisplayStartline(char startline, char side)
{
  if (side=='l') {CSPORT|=CS2; CSPORT&=~CS1;}  // left controller
  else if (side=='r') {CSPORT|=CS1; CSPORT&=~CS2;}  // right controller
  else if (side=='b') {CSPORT&=~CS1; CSPORT&=~CS2;}  // both controllers

  CONFIGPORT|=E; CONFIGPORT&=~RW; CONFIGPORT&=~DI;  // E=1, R/W=0, D/I=0
  DATAPORT=0xC0+startline; // startline setzen
  CONFIGPORT&=~E;         // E=0
}
