void InitUSART(char USART0, char USART1, unsigned int baudrate1, unsigned int baudrate2, char IR0, char IR1);
void SendUSART1(char* str);
void SendUSART0(char* str);
void SendUSART1c(char str);
void SendUSART0c(char str);

void InitUSART(char USART0, char USART1, unsigned int baudrate1, unsigned int baudrate2, char IR0, char IR1)
{
  if (USART0) ME1 |= UTXE0 + URXE0;    // falls gesetzt, USART0 einschalten (TX- und RX-teil)
  if (USART1) ME2 |= UTXE1 + URXE1;    // falls gesetzt, USART1 einschalten (TX- und RX-teil)
  UCTL0 |= CHAR;                       // 8 data bits, 1 stop bit, no parity (8N1)
  UCTL1 |= CHAR;
  UTCTL0 |= SSEL1;                     // SMCLK als UCLK festlegen
  UTCTL1 |= SSEL1;
  if (baudrate1==19200)
  {
    UBR00 = 0xA0;                      // 19200 baud aus 8 MHz erzeugen
    UBR10 = 0x01;                      // siehe application note tabelle 1, seite 9
    UMCTL0 = 0x00;                     // keine korrektur der division noetig
  }
  if (baudrate2==19200)
  {
    UBR01 = 0xA0;                      // 19200 baud aus 8 MHz erzeugen
    UBR11 = 0x01;                      // siehe application note tabelle 1, seite 9
    UMCTL1 = 0x00;                     // keine korrektur der division noetig
  }
  if (USART0) UCTL0 &= ~SWRST;         // USART freigeben
  if (USART1) UCTL1 &= ~SWRST;
  if (IR0==0) IE1 |= URXIE0;           // IR0: 0 -> nur RX-interrupt anschalten
  if (IR0==1) IE1 |= UTXIE0;           //      1 -> nur TX-interrupt anschalten
  if (IR0==2) IE1 |= URXIE0 + UTXIE0;  //      2 -> TX- und RX-interrupt anschalten
  if (IR1==1||IR1==2) IFG1 &= ~UTXIFG0;  // initales interrupt-flag loeschen
  if (IR1==0) IE2 |= URXIE1;           // IR1: 0 -> nur RX-interrupt anschalten
  if (IR1==1) IE2 |= UTXIE1;           //      1 -> nur TX-interrupt anschalten
  if (IR1==2) IE2 |= URXIE1 + UTXIE1;  //      2 -> TX- und RX-interrupt anschalten
  if (IR1==1||IR1==2) IFG1 &= ~UTXIFG1;  // initales interrupt-flag loeschen

}

void SendUSART0(char* str)             // einen string ber die serielle schnittstelle (USART0) senden
{
  while (*str != 0)
  {
    while (!(IFG1 & UTXIFG0));         // warten, bis USART0 TX-buffer sendebereit
    TXBUF0 = *str++;
  }
}

void SendUSART1(char* str)             // einen string ber die serielle schnittstelle (USART1) senden
{
  while (*str != 0)
  {
    while (!(IFG2 & UTXIFG1));         // warten, bis USART1 TX-buffer sendebereit
    TXBUF1 = *str++;
  }
}

void SendUSART0c(char str)             // ein einzelnes zeichen ber die serielle schnittstelle (USART0) senden
{
  while (!(IFG1 & UTXIFG0));           // warten, bis USART0 TX-buffer sendebereit
  TXBUF0 = str;
}

void SendUSART1c(char str)             // ein einzelnes zeichen ber die serielle schnittstelle (USART0) senden
{
  while (!(IFG2 & UTXIFG1));           // warten, bis USART1 TX-buffer sendebereit
  TXBUF1 = str;
}
